package com.shzg.project.worn.mapper;

import java.util.List;
import com.shzg.project.worn.domain.WornInboundItem;
import io.lettuce.core.dynamic.annotation.Param;

/**
 * 入库单明细Mapper接口
 * 
 * @author shzg
 * @date 2026-03-26
 */
public interface WornInboundItemMapper 
{
    /**
     * 查询入库单明细
     * 
     * @param id 入库单明细主键
     * @return 入库单明细
     */
    public WornInboundItem selectWornInboundItemById(Long id);

    /**
     * 查询入库单明细列表
     * 
     * @param wornInboundItem 入库单明细
     * @return 入库单明细集合
     */
    public List<WornInboundItem> selectWornInboundItemList(WornInboundItem wornInboundItem);

    /**
     * 新增入库单明细
     * 
     * @param wornInboundItem 入库单明细
     * @return 结果
     */
    public int insertWornInboundItem(WornInboundItem wornInboundItem);

    /**
     * 修改入库单明细
     * 
     * @param wornInboundItem 入库单明细
     * @return 结果
     */
    public int updateWornInboundItem(WornInboundItem wornInboundItem);

    /**
     * 删除入库单明细
     * 
     * @param id 入库单明细主键
     * @return 结果
     */
    public int deleteWornInboundItemById(Long id);

    /**
     * 批量删除入库单明细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteWornInboundItemByIds(Long[] ids);
//    /**
//     * 根据billId查询明细
//     */
//    public List<WornInboundItem> selectWornInboundItemByBillId(Long billId);
    /**
     * 根据单号和物料ID更新明细唯一码
     *
     * @param billNo 单号
     * @param materialId 物料ID
     * @param uniqueCode 唯一码
     * @return 结果
     */
    int updateUniqueCodeByBillNoAndMaterialId(@Param("billNo") String billNo,
                                              @Param("materialId") Long materialId,
                                              @Param("uniqueCode") Integer uniqueCode);

    int updateInboundItemStatus(WornInboundItem wornInboundItem);

    int countNotInboundByBillId(@Param("billId") Long billId);

    int updateItemToVoid(WornInboundItem item);

    List<WornInboundItem> selectWornInboundItemByBillId(Long billId);
}
